// Generated by LiveScript 1.5.0
var abbrev, red, fs, marked, TerminalRenderer, map, pkg, path, updateNotifier, commands, commandName, fullCommandName;
abbrev = require('abbrev');
red = require('chalk').red;
fs = require('fs');
marked = require('marked');
TerminalRenderer = require('marked-terminal');
map = require('prelude-ls').map;
pkg = require('../../package.json');
path = require('path');
updateNotifier = require('update-notifier');
updateNotifier({
  pkg: pkg
}).notify();
marked.setOptions({
  renderer: new TerminalRenderer()
});
commands = {
  add: "../../exo-add",
  clone: "../../exo-clone",
  clean: "../../exo-clean",
  create: "../../exo-create",
  deploy: "../../exo-deploy",
  lint: "../../exo-lint",
  run: "../../exo-run",
  setup: "../../exo-setup",
  sync: "../../exo-sync",
  test: "../../exo-test"
};
commandName = process.argv[2];
fullCommandName = completeCommandName(commandName);
if (commandName === 'version') {
  return console.log("Exosphere version " + pkg.version);
} else if (commandName === 'help') {
  process.argv.shift();
  help(process.argv[2]);
} else if (!commandName) {
  missingCommand();
} else if (!fullCommandName) {
  unknownCommand(commandName);
} else {
  process.argv.shift();
  require(commands[fullCommandName])();
}
function completeCommandName(commandName){
  return abbrev(commandNames())[commandName];
}
function missingCommand(){
  console.log(red("Error: missing command\n"));
  return printUsage();
}
function unknownCommand(command){
  console.log(red("Error: unknown command '" + command + "'\n"));
  return printUsage();
}
function printUsage(){
  var usageText;
  usageText = "**Usage: exo <command> [options]**\n\nAvailable commands are:\n  * add     Add a service to an existing application\n  * clean   Remove dangling Docker images and volumes\n  * clone   Download the source code of an application\n  * create  Create a new application or stand-alone service\n  * deploy  Deploy an application to the cloud\n  * lint    Verify the correctness of an application\n  * run     Run an application locally\n  * setup   Prepare a freshly cloned application for running it\n  * sync    Download updates for an application from its Git repository\n  * test    Run the tests for an application or service\n\nUse \"exo <command> help\" or \"exo help <command>\" for more information about a specific command.";
  return console.log(marked(usageText));
}
function help(command){
  if (!command) {
    return printUsage();
  }
  process.argv.push("help");
  process.argv.shift();
  if (commands[command]) {
    return require(commands[command])();
  } else {
    return unknownCommand(command);
  }
}
function commandNames(){
  return Object.keys(commands);
}