// Generated by LiveScript 1.5.0
var green, ref$, templatesPath, ServiceAdder, inquirer, fs, yaml, merge, N, path, empty, tmplconv, yamlCutter, service;
green = require('chalk').green;
ref$ = require('../../../exosphere-shared'), templatesPath = ref$.templatesPath, ServiceAdder = ref$.ServiceAdder;
inquirer = require('inquirer');
fs = require('fs');
yaml = require('js-yaml');
merge = require('merge');
N = require('nitroglycerin');
path = require('path');
empty = require('prelude-ls').empty;
tmplconv = require('tmplconv');
yamlCutter = require('yaml-cutter');
service = function(){
  var ref$, data, questions;
  console.log('We are about to create a new Exosphere service!\n');
  ref$ = ServiceAdder.parseCommandLine(process.argv), data = ref$.data, questions = ref$.questions;
  return inquirer.prompt(questions).then(function(answers){
    var srcPath, targetPath, appConfig, error;
    data = merge(data, answers);
    srcPath = path.join(templatesPath, 'add-service', data.templateName);
    targetPath = path.join(process.cwd(), '..', data.serviceType);
    try {
      appConfig = yaml.safeLoad(fs.readFileSync('application.yml', 'utf8'));
    } catch (e$) {
      error = e$;
      throw new Error("Creation of service '" + data.serviceRole + "' has failed.");
    }
    data.appName = appConfig.name;
    return tmplconv.render(srcPath, targetPath, {
      data: data
    }).then(function(){
      var options;
      options = {
        file: 'application.yml',
        root: 'services.public',
        key: data.serviceRole,
        value: {
          location: "../" + data.serviceType
        }
      };
      return yamlCutter.insertHash(options, N(function(){
        return console.log(green("\ndone"));
      }));
    });
  });
};
module.exports = service;