// Generated by LiveScript 1.5.0
var watch, EventEmitter, DockerHelper, path, ServiceWatcher;
watch = require('chokidar').watch;
EventEmitter = require('events').EventEmitter;
DockerHelper = require('../../exosphere-shared').DockerHelper;
path = require('path');
ServiceWatcher = (function(superclass){
  var prototype = extend$((import$(ServiceWatcher, superclass).displayName = 'ServiceWatcher', ServiceWatcher), superclass).prototype, constructor = ServiceWatcher;
  function ServiceWatcher(arg$){
    this.role = arg$.role, this.serviceLocation = arg$.serviceLocation, this.env = arg$.env, this.logger = arg$.logger;
    this.write = bind$(this, 'write', prototype);
    this.watch = bind$(this, 'watch', prototype);
    this.dockerConfigLocation = path.join(process.cwd(), 'tmp');
  }
  ServiceWatcher.prototype.watch = function(){
    /* Ignores any sub-path including dotfiles.
    '[\/\\]' accounts for both windows and unix systems, the '\.' matches a single '.', and the final '.' matches any character. */
    var x$, this$ = this;
    x$ = this.watcher = watch(this.serviceLocation, {
      ignoreInitial: true,
      ignored: [/.*\/node_modules\/.*/, /(^|[\/\\])\../]
    });
    x$.on('add', function(addedPath){
      this$.logger.log({
        role: 'exo-run',
        text: "Restarting service '" + this$.role + "' because " + addedPath + " was created"
      });
      return this$._restart();
    });
    x$.on('change', function(changedPath){
      this$.logger.log({
        role: 'exo-run',
        text: "Restarting service '" + this$.role + "' because " + changedPath + " was changed"
      });
      return this$._restart();
    });
    x$.on('unlink', function(removedPath){
      this$.logger.log({
        role: 'exo-run',
        text: "Restarting service '" + this$.role + "' because " + removedPath + " was deleted"
      });
      return this$._restart();
    });
    return x$;
  };
  ServiceWatcher.prototype._restart = function(){
    var cwd, this$ = this;
    this.watcher.close();
    cwd = this.dockerConfigLocation;
    return DockerHelper.killContainer({
      serviceName: this.role,
      cwd: cwd,
      write: this.write
    }, function(exitCode){
      switch (false) {
      case !exitCode:
        this$.emit('error', "Docker failed to kill container " + this$.role);
      }
      this$.write("Docker container stopped");
      return DockerHelper.createNewContainer({
        serviceName: this$.role,
        cwd: cwd,
        env: this$.env,
        write: this$.write
      }, function(exitCode){
        switch (false) {
        case !exitCode:
          this$.emit('error', "Docker image failed to rebuild " + this$.role);
        }
        this$.write("Docker image rebuilt");
        return DockerHelper.startContainer({
          serviceName: this$.role,
          cwd: cwd,
          env: this$.env,
          write: this$.write
        }, function(exitCode){
          switch (false) {
          case !exitCode:
            this$.emit('error', "Docker container failed to restart " + this$.role);
          }
          this$.watch();
          return this$.logger.log({
            role: 'exo-run',
            text: "'" + this$.role + "' restarted successfully"
          });
        });
      });
    });
  };
  ServiceWatcher.prototype.write = function(text){
    return this.logger.log({
      role: this.role,
      text: text,
      trim: true
    });
  };
  return ServiceWatcher;
}(EventEmitter));
module.exports = ServiceWatcher;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}