// Generated by LiveScript 1.5.0
var fs, ref$, ApplicationDependency, globalExosphereDirectory, Handlebars, yaml, path, Obj, map, os, DockerSetup;
fs = require('fs-extra');
ref$ = require('../../exosphere-shared'), ApplicationDependency = ref$.ApplicationDependency, globalExosphereDirectory = ref$.globalExosphereDirectory;
Handlebars = require('handlebars');
yaml = require('js-yaml');
path = require('path');
ref$ = require('prelude-ls'), Obj = ref$.Obj, map = ref$.map;
os = require('os');
DockerSetup = (function(){
  DockerSetup.displayName = 'DockerSetup';
  var prototype = DockerSetup.prototype, constructor = DockerSetup;
  function DockerSetup(arg$){
    this.appConfig = arg$.appConfig, this.role = arg$.role, this.logger = arg$.logger, this.serviceLocation = arg$.serviceLocation, this.dockerImage = arg$.dockerImage;
    this.getServiceDockerConfig = bind$(this, 'getServiceDockerConfig', prototype);
    if (this.serviceLocation) {
      this.serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(process.cwd(), this.serviceLocation, 'service.yml'), 'utf8'));
    }
  }
  DockerSetup.prototype.getServiceDockerConfig = function(){
    switch (false) {
    case !this.serviceConfig:
      return this._getServiceDockerConfig();
    default:
      return this._getExternalServiceDockerConfig();
    }
  };
  DockerSetup.prototype._getServiceDockerConfig = function(){
    var dockerConfig, ref$, dependency, ref1$, dependencyConfig;
    dockerConfig = {};
    dockerConfig[this.role] = Obj.compact({
      build: path.join('..', this.serviceLocation),
      container_name: this.role,
      command: this.serviceConfig.startup.command,
      ports: ((ref$ = this.serviceConfig.docker) != null ? ref$.ports : void 8) || undefined,
      links: this._getDockerLinks(),
      environment: this._getDockerEnvVars(),
      depends_on: this._getServiceDependencies()
    });
    for (dependency in ref1$ = this.serviceConfig.dependencies) {
      dependencyConfig = ref1$[dependency];
      dockerConfig[dependency + dependencyConfig.dev.version] = this._getServiceDependencyDockerConfig(dependency, dependencyConfig.dev);
    }
    return dockerConfig;
  };
  DockerSetup.prototype._getDockerLinks = function(){
    var links, dependency, ref$, dependencyConfig;
    links = [];
    for (dependency in ref$ = this.serviceConfig.dependencies) {
      dependencyConfig = ref$[dependency];
      links.push((dependency + dependencyConfig.dev.version) + ":" + dependency);
    }
    if (links.length) {
      return links;
    } else {
      return undefined;
    }
  };
  DockerSetup.prototype._getDockerEnvVars = function(){
    var envVars, i$, ref$, len$, dependencyConfig, dependency, ref1$;
    envVars = {
      ROLE: this.role
    };
    for (i$ = 0, len$ = (ref$ = this.appConfig.dependencies).length; i$ < len$; ++i$) {
      dependencyConfig = ref$[i$];
      dependency = ApplicationDependency.build(dependencyConfig);
      envVars = (ref1$ = {}, import$(ref1$, envVars), import$(ref1$, dependency.getServiceEnvVariables()));
    }
    for (dependency in this.serviceConfig.dependencies) {
      envVars[dependency.toUpperCase()] = dependency;
    }
    return envVars;
  };
  DockerSetup.prototype._getServiceDependencies = function(){
    var dependencies, dependency, ref$, dependencyConfig;
    dependencies = this._getAppDependencies();
    for (dependency in ref$ = this.serviceConfig.dependencies) {
      dependencyConfig = ref$[dependency];
      dependencies.push(dependency + "" + dependencyConfig.dev.version);
    }
    return dependencies;
  };
  DockerSetup.prototype._getServiceDependencyDockerConfig = function(dependencyName, dependencyConfig){
    var dataPath, renderedVolumes;
    if (dependencyConfig.volumes) {
      dataPath = globalExosphereDirectory(this.appConfig.name, dependencyName);
      fs.ensureDirSync(dataPath);
      renderedVolumes = map(function(volume){
        return Handlebars.compile(volume)({
          "EXO_DATA_PATH": dataPath
        });
      }, dependencyConfig.volumes);
    }
    return Obj.compact({
      image: dependencyConfig.image + ":" + dependencyConfig.version,
      container_name: dependencyName + dependencyConfig.version,
      ports: dependencyConfig.ports,
      volumes: renderedVolumes || undefined
    });
  };
  DockerSetup.prototype._getExternalServiceDockerConfig = function(){
    var dockerConfig;
    switch (false) {
    case !!this.dockerImage:
      throw new Error(red("No location or docker-image specified"));
    }
    dockerConfig = {};
    dockerConfig[this.role] = {
      image: this.dockerImage,
      container_name: this.role,
      depends_on: this._getAppDependencies()
    };
    return dockerConfig;
  };
  DockerSetup.prototype._getAppDependencies = function(){
    return map(function(dependencyConfig){
      return dependencyConfig.type + "" + dependencyConfig.version;
    }, this.appConfig.dependencies);
  };
  return DockerSetup;
}());
module.exports = DockerSetup;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}