// Generated by LiveScript 1.5.0
var async, EventEmitter, ref$, callArgs, DockerHelper, fs, yaml, ObservableProcess, path, wait, ServiceTester;
async = require('async');
EventEmitter = require('events').EventEmitter;
ref$ = require('../../exosphere-shared'), callArgs = ref$.callArgs, DockerHelper = ref$.DockerHelper;
fs = require('fs');
yaml = require('js-yaml');
ObservableProcess = require('observable-process');
path = require('path');
wait = require('wait').wait;
ServiceTester = (function(superclass){
  var prototype = extend$((import$(ServiceTester, superclass).displayName = 'ServiceTester', ServiceTester), superclass).prototype, constructor = ServiceTester;
  function ServiceTester(arg$){
    this.role = arg$.role, this.serviceLocation = arg$.serviceLocation, this.logger = arg$.logger;
    this.write = bind$(this, 'write', prototype);
    this._startDependencies = bind$(this, '_startDependencies', prototype);
    this._removeDependencies = bind$(this, '_removeDependencies', prototype);
    this.start = bind$(this, 'start', prototype);
    this.serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(this.serviceLocation, 'service.yml'), 'utf8'));
  }
  ServiceTester.prototype.start = function(done){
    var this$ = this;
    if (!this.serviceConfig.tests) {
      this.logger.log({
        role: 'exo-test',
        text: this.role + " has no tests, skipping"
      });
      return typeof done == 'function' ? done() : void 8;
    }
    return this._startDependencies(function(err){
      var x$;
      switch (false) {
      case !err:
        this$.logger.log({
          role: 'exo-test',
          text: "Error: " + err
        });
        return typeof done == 'function' ? done(err, 1) : void 8;
      }
      x$ = new ObservableProcess(callArgs(this$._createCommand(this$.serviceConfig.tests)), {
        cwd: this$.serviceLocation,
        stdout: {
          write: this$.write
        },
        stderr: {
          write: this$.write
        }
      });
      x$.on('ended', function(exitCode){
        if (exitCode > 0) {
          this$.logger.log({
            role: 'exo-test',
            text: this$.role + " is broken"
          });
        } else {
          this$.logger.log({
            role: 'exo-test',
            text: this$.role + " works"
          });
        }
        return this$._removeDependencies(function(err){
          return typeof done == 'function' ? done(err, exitCode) : void 8;
        });
      });
      return x$;
    });
  };
  ServiceTester.prototype._removeDependencies = function(done){
    var this$ = this;
    return async.eachSeries(this.dependencies, DockerHelper.removeContainer, function(err){
      switch (false) {
      case !err:
        done(err);
      }
      return done();
    });
  };
  ServiceTester.prototype._startDependencies = function(done){
    var dependencyName, ref$, dependencyConfig, that, this$ = this;
    this.dependencies = [];
    for (dependencyName in ref$ = this.serviceConfig.dependencies) {
      dependencyConfig = ref$[dependencyName];
      if (that = dependencyConfig.dev) {
        this.dependencies.push({
          Image: that.image + ":" + that.version,
          name: this.role + "-test-" + dependencyName,
          HostConfig: this._getPortMapping(that),
          onlineText: that['online-text']
        });
      }
    }
    return async.eachSeries(this.dependencies, DockerHelper.startContainer, function(err){
      switch (false) {
      case !err:
        done(err);
      }
      return done();
    });
  };
  ServiceTester.prototype._getPortMapping = function(dependencyConfig){
    var portMappings, i$, ref$, len$, portMapping, hostPort, containerPort;
    portMappings = {
      PortBindings: {}
    };
    for (i$ = 0, len$ = (ref$ = dependencyConfig.ports).length; i$ < len$; ++i$) {
      portMapping = ref$[i$];
      hostPort = portMapping.split(':')[0];
      containerPort = portMapping.split(':')[1];
      portMappings.PortBindings[containerPort + "/tcp"] = [{
        HostPort: hostPort
      }];
    }
    return portMappings;
  };
  ServiceTester.prototype._createCommand = function(command){
    if (this._isLocalCommand(command)) {
      command = path.join(this.serviceLocation, command);
    }
    return command;
  };
  ServiceTester.prototype._isLocalCommand = function(command){
    return command.substr(0, 2) === './';
  };
  ServiceTester.prototype.write = function(text){
    return this.logger.log({
      role: this.role,
      text: text
    });
  };
  return ServiceTester;
}(EventEmitter));
module.exports = ServiceTester;
function bind$(obj, key, target){
  return function(){ return (target || obj)[key].apply(obj, arguments) };
}
function extend$(sub, sup){
  function fun(){} fun.prototype = (sub.superclass = sup).prototype;
  (sub.prototype = new fun).constructor = sub;
  if (typeof sup.extended == 'function') sup.extended(sub);
  return sub;
}
function import$(obj, src){
  var own = {}.hasOwnProperty;
  for (var key in src) if (own.call(src, key)) obj[key] = src[key];
  return obj;
}