// Generated by LiveScript 1.5.0
var compileServiceRoutes, ExocomDependency;
compileServiceRoutes = require('../compile-service-routes');
ExocomDependency = (function(){
  ExocomDependency.displayName = 'ExocomDependency';
  var prototype = ExocomDependency.prototype, constructor = ExocomDependency;
  function ExocomDependency(arg$){
    this.version = arg$.version;
  }
  ExocomDependency.prototype.getEnvVariables = function(){
    return {
      EXOCOM_PORT: process.env.EXOCOM_PORT || 80
    };
  };
  ExocomDependency.prototype.getServiceEnvVariables = function(){
    return {
      EXOCOM_HOST: this._getContainerName(),
      EXOCOM_PORT: '$EXOCOM_PORT'
    };
  };
  ExocomDependency.prototype.getDockerConfig = function(appConfig, done){
    var this$ = this;
    return compileServiceRoutes({
      appConfig: appConfig
    }, function(err, serviceRoutes){
      var ref$;
      switch (false) {
      case !err:
        return done(err);
      }
      return done(null, (ref$ = {}, ref$[this$._getContainerName() + ""] = {
        image: "originate/exocom:" + this$.version,
        command: 'bin/exocom',
        container_name: this$._getContainerName(),
        environment: {
          ROLE: 'exocom',
          PORT: '$EXOCOM_PORT',
          SERVICE_ROUTES: JSON.stringify(serviceRoutes)
        }
      }, ref$));
    });
  };
  ExocomDependency.prototype._getContainerName = function(){
    return "exocom" + this.version;
  };
  return ExocomDependency;
}());
module.exports = ExocomDependency;