// Generated by LiveScript 1.5.0
var async, DockerHelper, fs, yaml, path;
async = require('async');
DockerHelper = require('./docker-helper');
fs = require('fs');
yaml = require('js-yaml');
path = require('path');
module.exports = function(arg$, done){
  var appConfig, basePath, serviceRoutes, i$, ref$, services, role, serviceData, serviceConfig, externalServices;
  appConfig = arg$.appConfig, basePath = arg$.basePath;
  serviceRoutes = [];
  for (i$ in ref$ = appConfig.services) {
    services = ref$[i$];
    for (role in services) {
      serviceData = services[role];
      if (serviceData.location) {
        serviceConfig = yaml.safeLoad(fs.readFileSync(path.join(basePath != null
          ? basePath
          : process.cwd(), serviceData.location, 'service.yml'), 'utf8'));
        serviceRoutes.push({
          role: role,
          receives: serviceConfig.messages.receives,
          sends: serviceConfig.messages.sends,
          namespace: serviceData.namespace
        });
      }
    }
  }
  externalServices = [];
  for (i$ in ref$ = appConfig.services) {
    services = ref$[i$];
    for (role in services) {
      serviceData = services[role];
      if (serviceData['docker-image']) {
        externalServices.push({
          image: serviceData['docker-image'],
          fileName: 'service.yml',
          role: role,
          namespace: serviceData.namespace
        });
      }
    }
  }
  return async.mapSeries(externalServices, function(){
    return DockerHelper.catFile(arguments[0], arguments[1]);
  }, function(err, externalServiceConfigs){
    var externalServiceIndex, i$, ref$, len$, externalService, serviceConfig;
    switch (false) {
    case !err:
      return done(null);
    }
    externalServiceIndex = 0;
    for (i$ = 0, len$ = (ref$ = externalServices).length; i$ < len$; ++i$) {
      externalService = ref$[i$];
      serviceConfig = yaml.safeLoad(externalServiceConfigs[externalServiceIndex]);
      serviceRoutes.push({
        role: externalService.role,
        receives: serviceConfig.messages.receives,
        sends: serviceConfig.messages.sends,
        namespace: externalService.namespace
      });
      externalServiceIndex++;
    }
    return done(null, serviceRoutes);
  });
};