// Generated by LiveScript 1.5.0
var ObservableProcess, DockerCompose;
ObservableProcess = require('observable-process');
DockerCompose = (function(){
  DockerCompose.displayName = 'DockerCompose';
  var prototype = DockerCompose.prototype, constructor = DockerCompose;
  DockerCompose.buildAllImages = function(arg$, done){
    var write, cwd, x$;
    write = arg$.write, cwd = arg$.cwd;
    x$ = new ObservableProcess(['docker-compose', 'build'], {
      cwd: cwd,
      stdout: {
        write: write
      },
      stderr: {
        write: write
      }
    });
    x$.on('ended', done);
    return x$;
  };
  DockerCompose.pullAllImages = function(arg$, done){
    var write, cwd, x$;
    write = arg$.write, cwd = arg$.cwd;
    x$ = new ObservableProcess(['docker-compose', 'pull'], {
      cwd: cwd,
      stdout: {
        write: write
      },
      stderr: {
        write: write
      }
    });
    x$.on('ended', done);
    return x$;
  };
  DockerCompose.runAllImages = function(arg$, done){
    var env, cwd, write, x$;
    env = arg$.env, cwd = arg$.cwd, write = arg$.write;
    x$ = new ObservableProcess(['docker-compose', 'up'], {
      cwd: cwd,
      env: env,
      stdout: {
        write: write
      },
      stderr: {
        write: write
      }
    });
    x$.on('ended', done);
    return x$;
  };
  DockerCompose.killContainer = function(arg$, done){
    var serviceName, cwd, write, x$;
    serviceName = arg$.serviceName, cwd = arg$.cwd, write = arg$.write;
    x$ = new ObservableProcess(['docker-compose', 'kill', serviceName], {
      cwd: cwd,
      stdout: {
        write: write
      },
      stderr: {
        write: write
      }
    });
    x$.on('ended', done);
    return x$;
  };
  DockerCompose.killAllContainers = function(arg$, done){
    var write, cwd, x$;
    write = arg$.write, cwd = arg$.cwd;
    x$ = new ObservableProcess(['docker-compose', 'down'], {
      cwd: cwd,
      stdout: {
        write: write
      },
      stderr: {
        write: write
      }
    });
    x$.on('ended', done);
    return x$;
  };
  DockerCompose.createNewContainer = function(arg$, done){
    var serviceName, cwd, env, write, x$;
    serviceName = arg$.serviceName, cwd = arg$.cwd, env = arg$.env, write = arg$.write;
    x$ = new ObservableProcess(['docker-compose', 'create', '--build', serviceName], {
      cwd: cwd,
      env: env,
      stdout: {
        write: write
      },
      stderr: {
        write: write
      }
    });
    x$.on('ended', done);
    return x$;
  };
  DockerCompose.startContainer = function(arg$, done){
    var serviceName, cwd, env, write, x$;
    serviceName = arg$.serviceName, cwd = arg$.cwd, env = arg$.env, write = arg$.write;
    x$ = new ObservableProcess(['docker-compose', 'restart', serviceName], {
      cwd: cwd,
      env: env,
      stdout: {
        write: write
      },
      stderr: {
        write: write
      }
    });
    x$.on('ended', done);
    return x$;
  };
  function DockerCompose(){}
  return DockerCompose;
}());
module.exports = DockerCompose;