// Generated by LiveScript 1.5.0
var async, ref$, any, head, map, Docker, stream, TextStreamAccumulator, TextStreamSearch, docker, DockerHelper;
async = require('async');
ref$ = require('prelude-ls'), any = ref$.any, head = ref$.head, map = ref$.map;
Docker = require('dockerode');
stream = require('stream');
TextStreamAccumulator = require('text-stream-accumulator');
TextStreamSearch = require('text-stream-search');
docker = new Docker;
DockerHelper = (function(){
  DockerHelper.displayName = 'DockerHelper';
  var prototype = DockerHelper.prototype, constructor = DockerHelper;
  DockerHelper.startContainer = function(arg$, done){
    var Image, name, HostConfig, onlineText;
    Image = arg$.Image, name = arg$.name, HostConfig = arg$.HostConfig, onlineText = arg$.onlineText;
    return DockerHelper.listRunningContainers(function(err, runningContainers){
      switch (false) {
      case !err:
        return done(err);
      case !runningContainers.includes(name):
        return done();
      default:
        return docker.createContainer({
          Image: Image,
          name: name,
          HostConfig: HostConfig
        }, function(err, container){
          switch (false) {
          case !err:
            done(err);
          }
          return container.attach({
            stream: true,
            stdout: true,
            stederr: true
          }, function(err, stream){
            var textStreamSearch;
            textStreamSearch = new TextStreamSearch(stream);
            return container.start(function(err){
              switch (false) {
              case !err:
                done(err);
              }
              return textStreamSearch.wait(onlineText, done);
            });
          });
        });
      }
    });
  };
  DockerHelper.removeContainer = function(arg$, done){
    var name;
    name = arg$.name;
    return docker.listContainers({
      name: name
    }, function(err, containers){
      switch (false) {
      case !err:
        return done(err);
      default:
        return DockerHelper._forceRemoveContainers(containers, done);
      }
    });
  };
  DockerHelper.removeContainers = function(done){
    return docker.listContainers(function(err, containers){
      switch (false) {
      case !err:
        return done(err);
      case !!containers.length:
        return done();
      default:
        return DockerHelper._forceRemoveContainers(containers, done);
      }
    });
  };
  DockerHelper.listRunningContainers = function(done){
    return docker.listContainers(function(err, containers){
      var this$ = this;
      switch (false) {
      case !err:
        return done(err);
      default:
        return done(null, map(function(it){
          var ref$;
          return function(it){
            return it.replace('/', '');
          }(
          (ref$ = it.Names) != null ? ref$[0] : void 8);
        }, containers));
      }
    });
  };
  DockerHelper.listImages = function(done){
    return docker.listImages(function(err, images){
      var this$ = this;
      switch (false) {
      case !err:
        return done(err);
      default:
        return done(null, map(function(it){
          return head(
          function(it){
            return it.split(':');
          }(
          head(
          it.RepoTags)));
        }, images));
      }
    });
  };
  DockerHelper.pullImage = function(arg$, done){
    var image;
    image = arg$.image;
    return docker.pull(image, function(err, stream){
      console.log("Downloading docker image for '" + image + "'...");
      return docker.modem.followProgress(stream, function(err, output){
        switch (false) {
        case !err:
          return done(err);
        default:
          console.log("'" + image + "' download complete");
          return done();
        }
      });
    });
  };
  DockerHelper.catFile = function(arg$, done){
    var image, fileName;
    image = arg$.image, fileName = arg$.fileName;
    return DockerHelper.pullImage({
      image: image
    }, function(err){
      var stdoutStream, textStreamSearch;
      switch (false) {
      case !err:
        return done(err);
      default:
        stdoutStream = new stream.PassThrough;
        textStreamSearch = new TextStreamAccumulator(stdoutStream);
        return docker.run(image, ['cat', fileName], stdoutStream, function(err, data, container){
          switch (false) {
          case !err:
            return done(err);
          default:
            return done(null, textStreamSearch.toString());
          }
        });
      }
    });
  };
  DockerHelper.pullImage = function(arg$, done){
    var image;
    image = arg$.image;
    return docker.pull(image, function(err, stream){
      console.log("Downloading docker image for '" + image + "'...");
      return docker.modem.followProgress(stream, function(err, output){
        switch (false) {
        case !err:
          return done(err);
        default:
          console.log("'" + image + "' download complete");
          return done();
        }
      });
    });
  };
  DockerHelper.catFile = function(arg$, done){
    var image, fileName;
    image = arg$.image, fileName = arg$.fileName;
    return DockerHelper.pullImage({
      image: image
    }, function(err){
      var stdoutStream, textStreamSearch;
      switch (false) {
      case !err:
        return done(err);
      default:
        stdoutStream = new stream.PassThrough;
        textStreamSearch = new TextStreamAccumulator(stdoutStream);
        return docker.run(image, ['cat', fileName], stdoutStream, function(err, data, container){
          switch (false) {
          case !err:
            return done(err);
          default:
            return done(null, textStreamSearch.toString());
          }
        });
      }
    });
  };
  DockerHelper.getDanglingImages = function(done){
    return docker.listImages({
      "filters": '{"dangling": ["true"]}'
    }, done);
  };
  DockerHelper.forceRemoveImages = function(images, done){
    return async.mapSeries(images, function(){
      return docker.getImage(arguments[0].Id).remove({
        force: true
      }, arguments[1]);
    }, done);
  };
  DockerHelper.getDanglingVolumes = function(done){
    return docker.listVolumes({
      "filters": '{"dangling": ["true"]}'
    }, function(err, volumes){
      switch (false) {
      case !err:
        return done(err);
      default:
        return done(null, volumes.Volumes || []);
      }
    });
  };
  DockerHelper.forceRemoveVolumes = function(volumes, done){
    return async.mapSeries(volumes, function(){
      return docker.getVolume(arguments[0].Name).remove({
        force: true
      }, arguments[1]);
    }, done);
  };
  DockerHelper._forceRemoveContainers = function(containers, done){
    return async.mapSeries(containers, function(){
      return docker.getContainer(arguments[0].Id).remove({
        force: true
      }, arguments[1]);
    }, done);
  };
  function DockerHelper(){}
  return DockerHelper;
}());
module.exports = DockerHelper;