// Generated by LiveScript 1.5.0
var fs, minimist, path, ServiceAdder;
fs = require('fs');
minimist = require('minimist');
path = require('path');
ServiceAdder = (function(){
  ServiceAdder.displayName = 'ServiceAdder';
  var prototype = ServiceAdder.prototype, constructor = ServiceAdder;
  ServiceAdder.serviceRoles = function(){
    return fs.readdirSync(path.join(path.join(__dirname, '..', 'templates', 'add-service')));
  };
  ServiceAdder.parseCommandLine = function(commandLineArgs){
    var parsedArgs, data, questions, serviceRole, serviceType, author, templateName, modelName, protectionLevel, description;
    parsedArgs = minimist(commandLineArgs);
    data = {};
    questions = [];
    serviceRole = parsedArgs['service-role'];
    serviceType = parsedArgs['service-type'];
    author = parsedArgs['author'];
    templateName = parsedArgs['template-name'];
    modelName = parsedArgs['model-name'];
    protectionLevel = parsedArgs['protection-level'];
    description = parsedArgs['description'];
    if (serviceRole) {
      data.serviceRole = serviceRole;
    } else {
      questions.push({
        message: 'Role of the service to create:',
        type: 'input',
        name: 'serviceRole',
        filter: function(input){
          return input.trim();
        },
        validate: function(input){
          return input.length > 0;
        }
      });
    }
    if (serviceType) {
      data.serviceType = serviceType;
    } else {
      questions.push({
        message: 'Type of the service to create:',
        type: 'input',
        name: 'serviceType',
        filter: function(input){
          return input.trim();
        },
        validate: function(input){
          return input.length > 0;
        }
      });
    }
    if (description) {
      data.description = description;
    } else {
      questions.push({
        message: 'Description:',
        type: 'input',
        name: 'description',
        filter: function(input){
          return input.trim();
        }
      });
    }
    if (author) {
      data.author = author;
    } else {
      questions.push({
        message: 'Author:',
        type: 'input',
        name: 'author',
        filter: function(input){
          return input.trim();
        },
        validator: function(input){
          return input.length > 0;
        }
      });
    }
    if (templateName) {
      data.templateName = templateName;
    } else {
      questions.push({
        message: 'Template:',
        type: 'list',
        name: 'templateName',
        choices: this.serviceRoles()
      });
    }
    if (modelName) {
      data.modelName = modelName;
    } else {
      questions.push({
        message: 'Name of the data model:',
        type: 'input',
        name: 'modelName',
        filter: function(input){
          return input.trim();
        }
      });
    }
    if (protectionLevel) {
      data.protectionLevel = protectionLevel;
    } else {
      questions.push({
        message: 'Protection level:',
        type: 'list',
        name: 'protectionLevel',
        choices: ['public', 'private']
      });
    }
    return {
      data: data,
      questions: questions
    };
  };
  function ServiceAdder(){}
  return ServiceAdder;
}());
module.exports = ServiceAdder;